//#define DEBUG 1
#include <bios.h>
#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#define ESC_KEY 283
#define I_KEY 5993
#define P_KEY 6512
#define C_KEY 11875
#define IN 0
#define OUT 1
#define SQR2 1.4142
#define SQR3 1.7321

float XSCALE = 7, YSCALE = 7;
float XCENTER = 320, YCENTER = 240;

class vector{
   public:
   float r, theta, phi;
   vector(){
       r = 0;
       theta = 0;
       phi = 0;
   }
   vector(float ax, float ay, float az){
       r = ax;
       theta = ay;
       phi = az;
   }
   void out(){
       printf("r=%f\t", r);
       printf("theta=%f\t", theta);
       printf("phi=%f\t", phi);
   }
};
vector operator +(vector a, vector b){
   vector c;
   c.r = a.r + b.r;
   c.theta = a.theta + b.theta;
   c.phi = a.phi + b.phi;
   return(c);
}
vector operator -(vector a, vector b){
   vector c;
   c.r = a.r - b.r;
   c.theta = a.theta - b.theta;
   c.phi = a.phi - b.phi;
   return(c);
}
vector operator *(float a, vector b){
   vector c;
   c.r = a * b.r;
   c.theta = a * b.theta;
   c.phi = a * b.phi;
   return(c);
}
vector operator *(vector b, float a){
   vector c;
   c.r = a * b.r;
   c.theta = a * b.theta;
   c.phi = a * b.phi;
   return(c);
}
vector operator *(vector a, vector b){
   vector c;
   c.r = a.theta * b.phi - a.phi * b.theta;
   c.theta = a.phi * b.r - a.r * b.phi;
   c.phi = a.r * b.theta - a.theta * b.r;

   return(c);
}

vector FieldB(vector r){
   vector res;
   float m = sqrt(r.r*r.r + r.theta*r.theta + r.phi*r.phi);
   res.r = (-2 * cos(r.theta) )/(m*m*m);
   res.theta = (- sin(r.theta) )/(m*m*m);
   res.phi = 0;
   return(res);
}

void main(){
   vector r1, r2, B;
   float r, theta, phi;
   float dl = 0.1;
   float Bm = 0;
   int i_phi=0, n_phi=10;
   float x, y, z, sx, sy;
   char firstflag = 1;
   int color = 1;
#ifndef DEBUG
   int gd=VGA, gm=VGAHI;
   initgraph(&gd, &gm, "egavga.bgi");
#endif
   for( ;color<16; color++){
       setcolor(color);
       for(i_phi=0; i_phi<n_phi; i_phi++){
           firstflag = 1;
           r = color;
           theta = 0.01;
           phi = (2*M_PI/n_phi)*i_phi;
           r1 = vector(r, theta, phi);

           while(r1.r>=1){
               if(bioskey(1)!=0){
	           int key = bioskey(0);
	           if(key==ESC_KEY) break;
                   if(key==C_KEY){
                       cleardevice();
                   }
               }
               B = FieldB(r1);
               Bm = sqrt(B.r*B.r + B.theta*B.theta + B.phi*B.phi);
               r1 = r1 - (1/Bm) * B * dl;

               x = r1.r * sin(r1.theta)*cos(r1.phi);
               y = r1.r * sin(r1.theta)*sin(r1.phi);
               z = r1.r * cos(r1.theta);

               sx = y * SQR3/2 - x * SQR3/2;
               sy = z - y/2 - x/2;

#ifndef DEBUG
               if(firstflag){
                   moveto(XCENTER + sx*XSCALE, YCENTER - sy*YSCALE);
                   putpixel(XCENTER + sx*XSCALE, YCENTER - sy*YSCALE, color);
                   firstflag = 0;
               }
               else{
                   lineto(XCENTER + sx*XSCALE, YCENTER - sy*YSCALE);
               }
#endif
           }
       }
   }
#ifndef DEBUG
   setcolor(WHITE);
   outtextxy(10,10,"Press any key to continue...");
#endif
   getch();
   closegraph();
}